proc ddhorthknife_makeframe {} {

   global ddhorthknife_sel_verts
   global ddhorthknife_delete_orthknife
   global ddhorthknife_knife_name
   set ddhorthknife_sel_verts 1
   set ddhorthknife_delete_orthknife 0
   set ddhorthknife_knife_name ""

   toplevel .ddhorthknife
   wm title .ddhorthknife "Ortho Knife"
   wm transient .ddhorthknife [winfo toplevel [winfo parent .ddhorthknife]]

   set width 6
   set ypad 3

   # Set orthknife
   frame .ddhorthknife.frmset
   pack .ddhorthknife.frmset -side top -fill x

   entry .ddhorthknife.frmset.txtknife -textvariable ddhorthknife_knife_name
   pack .ddhorthknife.frmset.txtknife -side left -fill x -expand 1
   button .ddhorthknife.frmset.btnset -text "Set Knife" -command {
      eval ac3d ddhorthknife_set
   }
   pack .ddhorthknife.frmset.btnset -side right -fill x -expand 1

   # Space
   frame .ddhorthknife.frmspace1
   pack .ddhorthknife.frmspace1 -side top -fill x -pady $ypad

   # Slice indicator
   frame .ddhorthknife.frmopts
   pack .ddhorthknife.frmopts -side top -fill x

   checkbutton .ddhorthknife.frmopts.chkselv -text "Select new vertices" -variable ddhorthknife_sel_verts
   pack .ddhorthknife.frmopts.chkselv -side top
   checkbutton .ddhorthknife.frmopts.chkdelorthknife -text "Delete entire knife object" -variable ddhorthknife_delete_orthknife
   pack .ddhorthknife.frmopts.chkdelorthknife -side bottom

   # Space
   frame .ddhorthknife.frmspace2
   pack .ddhorthknife.frmspace2 -side top -fill x -pady $ypad

   # Slice
   frame .ddhorthknife.frmbtn
   pack .ddhorthknife.frmbtn -side top -fill x

   button .ddhorthknife.frmbtn.btnapplyxy -text "Slice Front (XY)" -command {
      eval ac3d ddhorthknife_go $ddhorthknife_delete_orthknife 0 $ddhorthknife_sel_verts
   }
   pack .ddhorthknife.frmbtn.btnapplyxy -side top -fill x -expand 1
   button .ddhorthknife.frmbtn.btnapplyxz -text "Slice Top (XZ)" -command {
      eval ac3d ddhorthknife_go $ddhorthknife_delete_orthknife 1 $ddhorthknife_sel_verts
   }
   pack .ddhorthknife.frmbtn.btnapplyxz -side top -fill x -expand 1
   button .ddhorthknife.frmbtn.btnapplyyz -text "Slice Side (YZ)" -command {
      eval ac3d ddhorthknife_go $ddhorthknife_delete_orthknife 2 $ddhorthknife_sel_verts
   }
   pack .ddhorthknife.frmbtn.btnapplyyz -side top -fill x -expand 1

}

proc ddhorthknife_dialog {} {

   if ![winfo exists .ddhorthknife] {
      ddhorthknife_makeframe
   }

   wm deiconify .ddhorthknife
   centre_window_on_screen .ddhorthknife

}

